// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=67352

//+------------------------------------------------------------------+
//|                               Copyright © 2019, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//|                    BitCoin : 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF  |
//|               BitCoin Cash : 1BEtS465S3Su438Kc58h2sqvVvHK9Mijtg  |
//|           Ethereum : 0x8C110cD61538fb6d7A2B47858F0c0AaBd663068D  |
//|                   LiteCoin : LLU8PSY2vsq7B9kRELLZQcKf5nJQrdeqwD  |
//+------------------------------------------------------------------+

#property copyright "Copyright © 2019, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"
#property version   "1.1"
#property strict

#property indicator_chart_window

#property indicator_buffers 3
#property indicator_color1 clrAqua
#property indicator_style1 STYLE_SOLID;
#property indicator_color2 clrYellow
#property indicator_style2 STYLE_DOT
#property indicator_color3 clrAqua
#property indicator_style3 STYLE_SOLID

extern ENUM_TIMEFRAMES TF = PERIOD_CURRENT; // Timeframe
extern int BandsPeriod = 20; // Bands period
extern int BandsShift = 0; // Bands shift
extern double BandsDeviations = 1.5; // Bands deviations
//extern int button_x = 20;
//extern int button_y = 30;
extern int corner = 4;
extern int button_x = 200;
extern int button_y = 35;

double Up[], Center[], Down[];

string IndicatorName;
string IndicatorObjPrefix;

string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
bool show_data = true;
string buttonId;
int init()
{
   IndicatorName = GenerateIndicatorName("BB20");
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);

   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, Up);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, Center);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, Down);

   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "CloseButton";
   createButton(buttonId, "BB20", 45, 15, "Arial", 8, clrDarkRed, clrBlack, clrWhite);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);

   return 0;
}

void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
   ObjectDelete(0,buttonID);
   ObjectCreate(0,buttonID,OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
   ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
   ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
   ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
   ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
   ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
   ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
   ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
   ObjectSetString(0,buttonID,OBJPROP_FONT,font);
   ObjectSetString(0,buttonID,OBJPROP_TEXT,buttonText);
   ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
   ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
   ObjectSetInteger(0,buttonID,OBJPROP_CORNER,corner);
//   ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
}

int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   return 0;
}

bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}

int start()
{
   handleButtonClicks();
   int ExtCountedBars = IndicatorCounted();
   if (ExtCountedBars < 0) 
      return -1;
   int pos = Bars - 2;
   if (ExtCountedBars > 2 && !recalc) 
      pos = Bars - ExtCountedBars - 1;
   recalc = false;
   while (pos >= 0)
   {
      if (show_data)
      {
         int period = iBarShift(NULL, TF, Time[pos], true);
         Up[pos] = iBands(NULL, TF, BandsPeriod, BandsDeviations, BandsShift, PRICE_CLOSE, MODE_UPPER, period);
         Down[pos] = iBands(NULL, TF, BandsPeriod, BandsDeviations, BandsShift, PRICE_CLOSE, MODE_LOWER, period);
         Center[pos] = iBands(NULL, TF, BandsPeriod, BandsDeviations, BandsShift, PRICE_CLOSE, MODE_MAIN, period);
      }
      else
      {
         Up[pos] = EMPTY_VALUE;
         Down[pos] = EMPTY_VALUE;
         Center[pos] = EMPTY_VALUE;
      }
      pos--;
   } 
   return(0);
}

